<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_VisaOption ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_VisaOption extends AbstractStructArrayBase
{
    /**
     * The VisaOption
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_VisaOption[]
     */
    public $VisaOption;
    /**
     * Constructor method for ArrayOfJP_VisaOption
     * @uses ArrayOfJP_VisaOption::setVisaOption()
     * @param \StructType\JP_VisaOption[] $visaOption
     */
    public function __construct(array $visaOption = array())
    {
        $this
            ->setVisaOption($visaOption);
    }
    /**
     * Get VisaOption value
     * @return \StructType\JP_VisaOption[]|null
     */
    public function getVisaOption()
    {
        return $this->VisaOption;
    }
    /**
     * Set VisaOption value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_VisaOption[] $visaOption
     * @return \ArrayType\ArrayOfJP_VisaOption
     */
    public function setVisaOption(array $visaOption = array())
    {
        foreach ($visaOption as $arrayOfJP_VisaOptionVisaOptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_VisaOptionVisaOptionItem instanceof \StructType\JP_VisaOption) {
                throw new \InvalidArgumentException(sprintf('The VisaOption property can only contain items of \StructType\JP_VisaOption, "%s" given', is_object($arrayOfJP_VisaOptionVisaOptionItem) ? get_class($arrayOfJP_VisaOptionVisaOptionItem) : gettype($arrayOfJP_VisaOptionVisaOptionItem)), __LINE__);
            }
        }
        $this->VisaOption = $visaOption;
        return $this;
    }
    /**
     * Add item to VisaOption value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_VisaOption $item
     * @return \ArrayType\ArrayOfJP_VisaOption
     */
    public function addToVisaOption(\StructType\JP_VisaOption $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_VisaOption) {
            throw new \InvalidArgumentException(sprintf('The VisaOption property can only contain items of \StructType\JP_VisaOption, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->VisaOption[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_VisaOption|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_VisaOption|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_VisaOption|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_VisaOption|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_VisaOption|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VisaOption
     */
    public function getAttributeName()
    {
        return 'VisaOption';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_VisaOption
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
